#!/system/bin/sh

sleep 1

# Path
BASEDIR=/data/adb/modules/ActivityG
INT=/storage/emulated/0/
RWD=$INT/ActivityG
LOG=$RWD/ActivityG.log
MSC=$BASEDIR/script
BAL=$MSC/activity_balance.sh
PERF=$MSC/activity_performance.sh
SAV=$MSC/activity_powersaver.sh

# Check rewrite directory
if [ ! -e $RWD ]; then
  mkdir $RWD
fi

echo " " > $LOG
echo " Device info: " >> $LOG
echo " • Brand           : $(getprop ro.product.system.brand) " >> $LOG
echo " • Device          : $(getprop ro.product.system.model) " >> $LOG
echo " • Processor       : $(getprop ro.product.board) " >> $LOG
echo " • Android Version : $(getprop ro.system.build.version.release)" >> $LOG
echo " • SDK Version     : $(getprop ro.build.version.sdk) " >> $LOG
echo " • Architecture    : $(getprop ro.product.cpu.abi) " >> $LOG
echo " • Kernel Version  : $(uname -r)" >> $LOG
echo " " >> $LOG

echo " Profile Mode:" >> $LOG

# Check applist file
if [ ! -e $RWD/applist_perf.txt ]; then
  cp -f $MSC/applist_perf.txt $RWD
fi

# Begin of AI
sed -Ei 's/^description=(\[.*][[:space:]]*)?/description=[ Wait ] /g' "$BASEDIR/module.prop"
am start -a android.intent.action.MAIN -e toasttext "Tweak Applied." -n bellavita.toast/.MainActivity

# Start AI
setprop activity.mode notset
while true; do
   sleep 5
   app_list_filter="grep -o -e applist.app.add"
   while IFS= read -r applist || [[ -n "$applist" ]]; do
        filter=$(echo "$applist" | awk '!/ /')
        if [[ -n "$filter" ]]; then
          app_list_filter+=" -e "$filter
        fi
   done < "$RWD/applist_perf.txt"
   window=$(dumpsys window | grep package | $app_list_filter | tail -1)
   if [[ "$window" ]]; then
     if [[ $(getprop activity.mode) == "performance" ]]; then
       echo " "
     else
       sh $PERF
     fi
     sleep 5
   else
     if [[ $(getprop activity.mode) == "balance" ]]; then
       echo " "
     else
       sh $BAL
     fi
     sleep 2
   fi
   screen_status=$(dumpsys window | grep "mScreenOn" | grep false)
   if [[ "$screen_status" != "$prev_screen_status" ]]; then
      prev_screen_status="$screen_status"
      if [[ "$screen_status" ]]; then
         if [[ $(getprop activity.mode) == "powersaver" ]]; then
            echo " "
         else
            sh $SAV
         fi
         sleep 1
      fi
   fi
done