#!/system/bin/sh

# Sync to data in the rare case a device crashes
sync

# Functions
read_file(){
  if [[ -f $1 ]]; then
    if [[ ! -r $1 ]]; then
      chmod +r "$1"
    fi
    cat "$1"
  else
    echo "File $1 not found"
  fi
}

# Path
BASEDIR=/data/adb/modules/ActivityG
LOG=/storage/emulated/0/ActivityG/Balance.log
    
echo "1" > /sys/devices/system/cpu/cpu2/online
echo "1" > /sys/devices/system/cpu/cpu3/online

for policy in /sys/devices/system/cpu/cpufreq/policy*; do
    chmod 644 "$policy/scaling_governor"
    echo "schedutil" > "$policy/scaling_governor"
    if [ -f "$policy/schedutil/rate_limit_us" ]; then
        chmod 644 "$policy/schedutil/rate_limit_us"
        echo "2600" > "$policy/schedutil/rate_limit_us"
    fi
done

for device in /sys/class/devfreq/*; do
    if [ -f "$device/governor" ]; then
        chmod 644 "$device/governor"
        echo "simple_ondemand" > "$device/governor"
    fi
done

if [ -d /proc/gpufreq ]; then
	apply "0" /proc/gpufreq/gpufreq_opp_freq 2>/dev/null
elif [ -d /proc/gpufreqv2 ]; then
	apply -1 /proc/gpufreqv2/fix_target_opp_index
fi

# Power Level
for pl in /sys/devices/system/cpu/perf
    do
        echo 0 > "$pl/gpu_pmu_enable"
        echo -1 > "$pl/gpu_pmu_period"
        echo 0 > "$pl/fuel_gauge_enable"
        echo teo > "$pl/current_governor"
        echo 0 > "$pl/enable"
        echo 1 > "$pl/charger_enable"
    done
    
echo 1 > /proc/ppm/enabled


# Set balance
setprop activity.mode balance
echo " •> Balance Mode at $(date "+%H:%M:%S")" >> $LOG

# Report
sed -Ei 's/^description=(\[.*][[:space:]]*)?/description=[ Balance Mode ] /g' "$BASEDIR/module.prop"
am start -a android.intent.action.MAIN -e toasttext "Balance Mode" -n bellavita.toast/.MainActivity

exit 0