#!/system/bin/sh
#By MiAzami

# Waiting for boot completed
while [ "$(getprop sys.boot_completed | tr -d '\r')" != "1" ]; do sleep 5; done

# Path
MODDIR=${0%/*}

# Device online functions
wait_until_login()
{
    # whether in lock screen, tested on Android 7.1 & 10.0
    # in case of other magisk module remounting /data as RW
    while [ "$(dumpsys window policy | grep mInputRestricted=true)" != "" ]; do
        sleep 2
    done
    # we doesn't have the permission to rw "/sdcard" before the user unlocks the screen
    while [ ! -d "/sdcard/Android" ]; do
        sleep 2
    done
}

# Enable all tweak
sed -Ei 's/^description=(\[.*][[:space:]]*)?/description=[ Running ] /g' "$MODDIR/module.prop"
su -lp 2000 -c "cmd notification post -S bigtext -t 'ActivityG' tag 'Running'" >/dev/null 2>&1

# Sync to data in the rare case a device crashes
sync

for device in /sys/block/*; do
    if [ ! -d "$device/queue" ]; then
        continue
    fi
    queue="$device/queue"
    echo 128 > "$queue/nr_requests"
    echo 2048 > "$queue/read_ahead_kb"
    if [ -f "$queue/scheduler" ]; then
        echo "deadline" > "$queue/scheduler"
    fi
done

#printk
echo "0 0 0 0" > /proc/sys/kernel/printk
echo "1" > /sys/module/printk/parameters/console_suspend
echo "1" > /sys/module/printk/parameters/ignore_loglevel
echo "0" > /sys/module/printk/parameters/time
echo "off" > /proc/sys/kernel/printk_devkmsg

# Networking tweaks
echo "cubic" > /proc/sys/net/ipv4/tcp_congestion_control
echo "1" > /proc/sys/net/ipv4/tcp_low_latency
echo "1" > /proc/sys/net/ipv4/tcp_ecn
echo "1" > /proc/sys/net/ipv4/tcp_sack
echo "1" > /proc/sys/net/ipv4/tcp_timestamps
echo "3" > /proc/sys/net/ipv4/tcp_fastopen
echo "3" > /proc/sys/net/ipv4/tcp_fastopen

echo "1" > /sys/module/mtk_core_ctl/parameters/policy_enable
echo N > /sys/module/sync/parameters/fsync_enabled

# Done
sleep 1
sed -Ei 's/^description=(\[.*][[:space:]]*)?/description=[  Tweak Applied ] /g' "$MODDIR/module.prop"
su -lp 2000 -c "cmd notification post -S bigtext -t 'ActivityG' tag 'Tweak Applied'" >/dev/null 2>&1

# Run Ai
sleep 1
nohup sh $MODDIR/script/activity_auto.sh &
